#ifndef _GAME_H_
#define _GAME_H_

#include <app/Engine.h>
#include <SFML/Graphics.hpp>
#include <vector>

using namespace sf;
using namespace std;

class Level;
class CTexture;
class MainScreen;
class Instructions;

class Game : public CEngine
{

	Level *m_Level;
	Font m_DefaultFont;

	vector<Image*> m_TabImgPath;
	vector<CTexture*> m_TabTextPath;

	vector<Image*> m_TabImgObs;
	vector<CTexture*> m_TabTextObs;

	MainScreen *m_MainScreen;
	Instructions *m_Instructions;

	enum State {
		MAIN_SCREEN,
		GAME,
		INSTRUCTIONS
	} m_State;

public:
	Image m_imgInterface;

private:
	Game(void);
	~Game(void);

public:
	static Game* Get();

	bool InitGame();
	void DeInitGame();

	bool FrameMove();
	bool Render();

	// Interactions avec le joueur
	bool ExecuteAction( int action );
	bool KeyPressed( Key::Code key );
	bool KeyUnPressed( Key::Code key );
	bool MousePressed( Event mouseButton );
	bool MouseReleased( Event mouseButton );
	bool MouseOver( int x, int y );
	bool TextEntered( Event::TextEvent text);
	bool MouseWheelMoved( Event::MouseWheelEvent wheel);

	const Font& GetDefaultFont();
	CTexture* GetPathTexture(int index);
	CTexture* GetObsTexture(int index);
};

#endif
