#include "MovingObstacle.h"
#include <iostream>

MovingObstacle::MovingObstacle(CTexture *texture, Vector2f pos, Vector2f speed, float limitMin, float limitMax, bool limitAxis):
Obstacle	(texture, pos),
m_Speed		(speed),
m_LimitAxis	(limitAxis),
m_Direction	(1.f)
{
	m_LimitMin = (m_LimitAxis ? pos.x : pos.y) - limitMin;
	m_LimitMax = (m_LimitAxis ? pos.x : pos.y) + limitMax;
}

MovingObstacle::~MovingObstacle(void)
{
}

void MovingObstacle::FrameMove(float elapsedTime)
{
	m_Texture->Move( m_Direction * m_Speed.x * elapsedTime,
		m_Direction * m_Speed.y * elapsedTime);

	// x
	if( m_LimitAxis )
	{
		if( m_Texture->GetPosition().x < m_LimitMin )
		{
			m_Texture->SetPosition(m_LimitMin, m_Texture->GetPosition().y);
			m_Direction = -m_Direction;
		}
		else if( m_Texture->GetPosition().x > m_LimitMax )
		{
			m_Texture->SetPosition(m_LimitMax, m_Texture->GetPosition().y);
			m_Direction = -m_Direction;
		}
	}
	else	// y
	{
		if( m_Texture->GetPosition().y < m_LimitMin )
		{
			m_Texture->SetPosition(m_Texture->GetPosition().x, m_LimitMin);
			m_Direction = -m_Direction;
		}
		else if( m_Texture->GetPosition().y > m_LimitMax )
		{
			m_Texture->SetPosition(m_Texture->GetPosition().x, m_LimitMax);
			m_Direction = -m_Direction;
		}
	}
}
