#ifndef _OBSTACLE_H_
#define _OBSTACLE_H_

#include <SFML/Graphics.hpp>
#include <graphics/Texture.h>

using namespace sf;

class Obstacle
{
protected:
	// Has to be deleted with the class
	CTexture *m_Texture;

public:
	Obstacle(CTexture *texture = NULL, Vector2f pos = Vector2f(0.f, 0.f));
	virtual ~Obstacle(void);

	virtual void FrameMove(float elapsedTime);
	void Render(RenderWindow &screen);

	// Detect collision with the obstacle (texture)
	bool Collide(float x, float y);

	void SetTexture(CTexture *texture);
	void SetPosition(Vector2f pos);
};

#endif
