#include "Instructions.h"
#include "../Game.h"
#include "../Define.h"
#include "TitleEffect.h"

Instructions::Instructions(void)
{
	m_Aim.SetFont(Game::Get()->GetDefaultFont());
	m_Aim.SetString("L'objectif de Reward - Forward est d'atteindre la ligne d'arrive\nle plus rapidement. Le parcours est tordu et comporte de nombreux\nobstacles. Il est possible d'altrer la vitesse du temps, d'acclrer\nou de ralentir. A vous d'en faire bon usage.");
	m_Aim.SetPosition(10.f, 100.f);
	m_Aim.SetScale(0.6f, 0.6f);

	m_CmdTitle.SetFont(Game::Get()->GetDefaultFont());
	m_CmdTitle.SetString("Commandes:");
	m_CmdTitle.SetStyle(Text::Underlined);
	m_CmdTitle.SetPosition(10.f, 200.f);
	m_CmdTitle.SetColor(Color(0, 147, 255));

	m_Cmd.SetFont(Game::Get()->GetDefaultFont());
	m_Cmd.SetString("Acclrer: Clic gauche ou molette vers le haut\nRalentir: Clic droit ou molette vers le bas\n");
	m_Cmd.SetPosition(10.f, 240.f);
	m_Cmd.SetScale(0.6f, 0.6f);

	m_Logo.LoadFromFile("resources/sfml-logo.png");
	m_spLogo.SetImage(m_Logo);
	m_spLogo.SetScale(0.5f, 0.5f);
	m_spLogo.SetOrigin(m_Logo.GetWidth() / 2, m_Logo.GetHeight() / 2);
	m_spLogo.SetPosition(SCREEN_WIDTH / 2, SCREEN_HEIGHT - 180);

	m_imgRF = WidgetImage( IntRect( 137, 51, 258, 30), Vector2i(129, 129), Game::Get()->m_imgInterface);
	m_Title = new TitleEffect(Vector2f((SCREEN_WIDTH - 162) / 2, 30.f), Game::Get()->m_imgInterface);
}

Instructions::~Instructions(void)
{
	delete m_Title;
}

bool Instructions::FrameMove(float elapsedTime)
{
	m_Title->FrameMove(elapsedTime);
	return false;
}

void Instructions::Render(RenderWindow &screen) const
{
	screen.Draw(m_CmdTitle);
	screen.Draw(m_Aim);
	screen.Draw(m_Cmd);

	screen.Draw(m_spLogo);

	m_Title->Render(screen);
}

int Instructions::MousePressed( int x, int y)
{
	return CMD_EXIT;
}
