#include "MainScreen.h"
#include "../Game.h"
#include "../Define.h"
#include <gui/Button.h>

MainScreen::MainScreen(void)
{
	Button *pBtn = NULL;

	m_imgRF = WidgetImage( IntRect( 137, 51, 258, 30), Vector2i(129, 129), Game::Get()->m_imgInterface);

	m_imgBtnGray = WidgetImage( IntRect( 0, 7, 12, 32), Vector2i(4, 4), Game::Get()->m_imgInterface);
	m_imgBtnBlue = WidgetImage( IntRect( 12, 7, 12, 32), Vector2i(4, 4), Game::Get()->m_imgInterface);
	m_imgBtnRed = WidgetImage( IntRect( 24, 7, 12, 32), Vector2i(4, 4), Game::Get()->m_imgInterface);

	m_FontWhite = CFont("resources/OCRAExt.ttf", Color::White, 20);
	m_FontBlack = CFont("resources/OCRAExt.ttf", Color::Black, 20);
	
	_Title = new TitleEffect(Vector2f((SCREEN_WIDTH - 162) / 2, 180.f), Game::Get()->m_imgInterface);
	m_Wnd = new myLib::Window((SCREEN_WIDTH - 230) / 2, (SCREEN_HEIGHT - 96) / 2);

	// ,Play
	pBtn = new Button( 0, 0, 230, 32, CMD_PLAY, &m_imgBtnGray, &m_FontBlack, 30, 2, ",Play");
	pBtn->SetImageHover(&m_imgBtnBlue);
	m_Wnd->AddWidget(pBtn);
	// 'Options
	pBtn = new Button( 0, 32, 230, 32, CMD_INSTRUCTIONS, &m_imgBtnGray, &m_FontBlack, 30, 2, ",Instructions");
	pBtn->SetImageHover(&m_imgBtnBlue);
	m_Wnd->AddWidget(pBtn);
	// 'Exit
	pBtn = new Button( 0, 64, 230, 32, CMD_EXIT, &m_imgBtnGray, &m_FontBlack, 30, 2, ",Exit");
	pBtn->SetImageHover(&m_imgBtnRed);
	pBtn->SetFontHover(&m_FontWhite);
	m_Wnd->AddWidget(pBtn);
}

MainScreen::~MainScreen(void)
{
	delete m_Wnd;
	delete _Title;
}

bool MainScreen::FrameMove(float elapsedTime)
{
	_Title->FrameMove(elapsedTime);
	return false;
}

void MainScreen::Render(RenderWindow &screen) const
{
	_Title->Render(screen);
	m_Wnd->Render(screen, Vector2i(0,0));
}

int MainScreen::MousePressed( int x, int y)
{
	return m_Wnd->MousePressed(x, y);
}

int MainScreen::MouseReleased( int x, int y)
{
	return m_Wnd->MouseReleased(x, y);
}

void MainScreen::MouseHover( int x, int y)
{
	m_Wnd->MouseHover(x, y);
}
