#ifndef MAIN_SCREEN_H
#define MAIN_SCREEN_H

#include "screen.h"
#include <gui/Window.h>
#include <gui/WidgetImage.h>
#include <graphics/Font.h>
#include "TitleEffect.h"

class MainScreen :
	public Screen
{
	myLib::Window *m_Wnd;

	WidgetImage m_imgRF;
	TitleEffect *_Title;

	WidgetImage m_imgBtnGray;
	WidgetImage m_imgBtnBlue;
	WidgetImage m_imgBtnRed;

	CFont m_FontWhite;
	CFont m_FontBlack;

public:
	MainScreen(void);
	virtual ~MainScreen(void);
	
	virtual bool FrameMove(float elapsedTime);
	virtual void Render(RenderWindow &screen) const;

	int MousePressed( int x, int y);
	int MouseReleased( int x, int y);
	void MouseHover( int x, int y);

	inline void Display(bool display){ _Title->Reset(); m_Display = display; }
};

#endif
