#include "TitleEffect.h"


TitleEffect::TitleEffect(const Vector2f& position, const Image& img):
_Timer	(0.f)
{
	float offsetX = 0.f;
	float x = position.x;
	float y = position.y;

	_LetterWidth[0] = 35.f;
	_LetterWidth[1] = 38.f;
	_LetterWidth[2] = 33.f;
	_LetterWidth[3] = 38.f;

	_Glow = Sprite(img, Vector2f(x - 12.f, y));
	_Glow.SetSubRect(IntRect(0, 207, 162, 49));
	_Glow.SetColor(Color(255, 255, 255, 0));

	Sprite sp;
	for( int i = 0; i < TITLE_SIZE; i++)
	{
		sp = Sprite(img);
		sp.SetSubRect(IntRect(12 + static_cast<int>(offsetX),
			157,
			static_cast<int>(_LetterWidth[i]),
			49));
		sp.SetPosition(x + offsetX, y);

		_BlinkLetters[i] = new BlinkEffect(Vector2f(sp.GetPosition().x + sp.GetSize().x / 2.f, sp.GetPosition().y + sp.GetSize().y / 2.f),
			static_cast<int>(_LetterWidth[i]),
			6,
			Color(0, 200, 255));

		_BlinkLetters[i]->AddSprite(sp);

		offsetX += _LetterWidth[i];
	}
}


TitleEffect::~TitleEffect(void)
{
	for( int i = 0; i < TITLE_SIZE; i++)
	{
		delete _BlinkLetters[i];
	}
}

bool TitleEffect::FrameMove(float elapsedTime)
{
	_Timer += elapsedTime;

	if( _Timer * 100 < 255.f)
		_Glow.SetColor(Color(255, 255, 255, static_cast<sf::Uint8>(_Timer * 100)));

	for( int i = 0; i < TITLE_SIZE; i++)
	{
		if( _Timer > i * 0.1f)
			_BlinkLetters[i]->FrameMove(elapsedTime);
	}

	return false;
}

void TitleEffect::Render(sf::RenderWindow &screen)
{
	screen.Draw(_Glow);
	for( int i = 0; i < TITLE_SIZE; i++)
	{
		_BlinkLetters[i]->Render(screen);
	}
}

void TitleEffect::Reset()
{
	_Timer = 0.f;
	for( int i = 0; i < TITLE_SIZE; i++)
	{
		_BlinkLetters[i]->Reset();
	}
}

