#include "Game.h"
#include "Define.h"
#include <iostream>
#include <fstream>

 #include <SFML/Graphics.hpp>

using namespace std;
using namespace sf;

int main( int argc, char* argv[] )
{
	bool quit = false;
	cout << "Initialisation du jeu\n" << endl;

	// Redirect err stream to file
	streambuf *fileBuf;
	ofstream fileErr;
	fileErr.open ("err.txt");

	// get file's streambuf
	fileBuf = fileErr.rdbuf();
	// assign streambuf to cerr
	cerr.rdbuf(fileBuf);

	Game *game = Game::Get();

	if( !game->InitApp( "Reward - Forward", SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP) )
	{
		cerr << "L'application n'a pu s'initialiser correctement" << endl;
		return EXIT_FAILURE;
	}
	if( !game->InitGame() )
	{
		cerr << "Le jeu n'a pu s'initialiser correctement" << endl;
		return EXIT_FAILURE;
	}

	while( !quit )
	{
		quit = game->UserEvent();
		game->FrameMove();
		game->Render();
	}
	game->DeInitGame();
	game->DeInitApp();

	//Sleep(1.0f);

	fileErr.close();

	//system("PAUSE");
	return EXIT_SUCCESS;
}
