#ifndef ENGINE_H
#define ENGINE_H

#include <SFML/Window.hpp>
#include <SFML/Graphics.hpp>
#include <SFML/Audio.hpp>
#include "Timer.h"


using namespace sf;

class CEngine
{
private:
	Event m_Event;

protected:
	static float m_lastTime;
	static float m_elapsedTime;
	Timer m_Timer;

	double _FpsLastTime;
	int _Fps;

	static RenderWindow m_Screen;

public:
	CEngine(void);
public:
	virtual	~CEngine(void);

	////////////////////////////////////////////////////////////
	// Initialize the game by creating the main window
	////////////////////////////////////////////////////////////
	bool InitApp( const char *name, unsigned int width, unsigned int height, unsigned int bpp = 32);
	void DeInitApp();

	virtual bool InitGame() = 0;
	virtual void DeInitGame() = 0;

	// Interactions avec le joueur
	virtual bool ExecuteAction( int action ) = 0;
	virtual bool KeyPressed( Key::Code key ) = 0;
	virtual bool KeyUnPressed( Key::Code key ) = 0;
	virtual bool MousePressed( Event mouseButton ) = 0;
	virtual bool MouseReleased( Event mouseButton ) = 0;
	virtual bool MouseOver( int x, int y ) = 0;
	virtual bool TextEntered( Event::TextEvent text) = 0;
	virtual bool MouseWheelMoved( Event::MouseWheelEvent wheel) = 0;

	virtual bool UserEvent();
	virtual bool FrameMove();	// Fonctions principales de jeu,
	virtual bool Render() = 0;		// piliers de toute l'application

private:
	void CalcFps();
};

#endif
