#ifndef _BLINK_EFFECT_H
#define _BLINK_EFFECT_H

#include <SFML\Graphics.hpp>

using namespace sf;

class BlinkEffect
{
	int _NbLines;
	// Line array
	Sprite *_Lines;
	float *_LineAlpha;	// alpha value of a line
	float *_LineScale;	// scale value of a line

	float _FadingSpeed;	// Fading speed
	float _ScaleFactor;	// Scale factor
	float _SpawnSpeed;	// Nb lines / second

	Sprite _Sprite;

	// For internal use
	float _Timer;
	Image _ImgLine;		// Image of the line
	float _SpFadingSpeed;

public:
	// x, y: position of the effect (center)
	BlinkEffect(const Vector2f& pos = Vector2f(0.f, 0.f), int width = 20, int nbLines = 5, const Color& col = Color::White,
		float fadingSpeed = 400.f, float scaleFactor = 8.f, float spawnSpeed = 10.f);
	~BlinkEffect(void);

	// Restart the animation
	void Reset(void);

	void AddSprite(const Sprite& sp);

	bool FrameMove(float elapsedTime);
	void Render(sf::RenderWindow &screen);
};

#endif
