#ifndef FRAME_H
#define FRAME_H

/*======================================================
//	Frame
//		-Permet de dessiner un cadre avec un fond
//		 une position avec une taille donne
//
//	Auteur: Bryce
//	Version: 1.0
//	Dernire modif: 1/12/08
===================================================*/

#include "FrameImage.h"
#include <graphics/GraphicObject.h>

using namespace sf;

class Frame : public CGraphicObject
{
	FrameImage *m_imgFrame;

public:
	Frame(void);
	// - x,y: positionnement sur l'cran
	// - width, height: dimension du cadre
	// - imgFrame: ptr vers le cadre
	Frame( float x, float y, unsigned int width, unsigned int height, FrameImage *imgFrame=NULL);
	~Frame(void);

	// Assigne l'image du cadre
	void SetFrameImage( FrameImage *imgFrame);

	virtual bool FrameMove( float elapsedTime );
	virtual void Render( RenderWindow &screen);
	virtual void Render( RenderWindow &screen, float dx, float dy);
	
	int GetClientX(void) const;
	int GetClientY(void) const;
	int GetClientWidth(void) const;
	int GetClientHeight(void) const;
};

#endif
