#ifndef FRAMEIMAGE_H
#define FRAMEIMAGE_H

#include <graphics/Texture.h>

using namespace sf;

//////////////////////////////////////////////////////////////////////
// Permet de dessiner un cadre avec un fond
//	-la taille de chaque bordure est rglable
//	-l'image d'o est extrait le cadre doit tre correctement format
//		selon les dimensions demandes
//  -rsultat:  0 - 0
//				| 0 |
//				0 - 0
//////////////////////////////////////////////////////////////////////
class FrameImage
{
	// Dimension des bordures horizontal suprieure (x) et infrieure (y)
	Vector2i m_BordHorizontal;
	// Dimension des bordures vertical gauche (x) et droite (y)
	Vector2i m_BordVertical;

	// Textures reprsentant la bordure
	CTexture *m_Bordure[9];

	// Affichage actif
	bool m_Enable;

public:
	enum Bordure {
		COIN_HG,
		BORD_HAUT,
		COIN_HD,
		BORD_GAUCHE,
		FOND,
		BORD_DROITE,
		COIN_BG,
		BORD_BAS,
		COIN_BD
	};

public:
	FrameImage(void);
	FrameImage(	unsigned int x, unsigned int y, unsigned int width, unsigned int height,
					unsigned int bordHaut, unsigned int bordBas, unsigned int bordGauche, unsigned int bordDroit, const Image& img);
	~FrameImage(void);

	// - width doit tre suprieur  la largeur minimale (somme des bordures verticales)
	// - height doit tre suprieur  la hauteur minimale (somme des bordures horizontales)
	bool Render( RenderWindow &screen, float x, float y, unsigned int width, unsigned int height);

	inline bool IsEnabled(void) const { return m_Enable; }
	void Enable(bool enable);

	inline int GetLeftSideWidth(void) const		{ return m_BordVertical.x; }
	inline int GetRightSideWidth(void) const	{ return m_BordVertical.y; }
	inline int GetTopSideWidth(void) const		{ return m_BordHorizontal.x; }
	inline int GetBottomSideWidth(void) const	{ return m_BordHorizontal.y; }
};
#endif
