#ifndef GRAPHIC_OBJECT_H
#define GRAPHIC_OBJECT_H

#include <SFML/Graphics.hpp>
#include <SFML/System.hpp>
#include <vector>

using namespace sf;

class CGraphicObject
{
protected:
	// Dimension de l'lment
	Vector2i m_Size;

	// Position de l'lment
	Vector2f m_Position;

public:
	CGraphicObject(void);
	CGraphicObject( float x, float y, unsigned int width, unsigned int height);
public:
	virtual ~CGraphicObject(void);

	// Animation de l'lment
	virtual bool FrameMove( float elapsedTime ) = 0;

	// Affichage de l'lment avec dcalage
	virtual void Render( RenderWindow &screen, float dx, float dy) = 0;

	// Renvoi les dimensions
	virtual int GetWidth() const { return m_Size.x; }
	virtual int GetHeight() const { return m_Size.y; }

	virtual void SetWidth(int width) { m_Size.x = width; }
	virtual void SetHeight(int height) { m_Size.y = height; }

	// Renvoi la position
	virtual float GetX() const { return m_Position.x; }
	virtual float GetY() const { return m_Position.y; }

	virtual void SetX(float x) { m_Position.x = x; }
	virtual void SetY(float y) { m_Position.y = y; }
};

typedef std::vector<CGraphicObject*> TGraphicObjectVector ;

class CGraphicObjectVector : public TGraphicObjectVector
{
public:
	~CGraphicObjectVector(void);

	bool FrameMove( float elapsedTime );
	void Render( RenderWindow &screen);
	void Render( RenderWindow &screen, float dx, float dy);

	// Supprime chaque lment du vecteur et vide le vecteur
	void DeleteAll(void);
};

#endif
