#ifndef WIDGET_IMAGE_H
#define WIDGET_IMAGE_H

#include <graphics/Texture.h>
#include <SFML/graphics.hpp>

using namespace sf;

class WidgetImage
{
	CTexture m_imgLeft;
	CTexture m_imgRight;
	CTexture m_imgCenter;

public:
	WidgetImage();
	/// <summary>
	/// 
	/// </summary>
	/// <param name="rect">coordonnes de l'image  extraire</param>
	/// <param name="sides">dimension du ct droit et gauche</param>
	/// <param name="img">image d'origine</param>
	/// <param name="imgDisable"></param>
	WidgetImage(IntRect rect, Vector2i sides, const Image& img);

	~WidgetImage();

	void Render(RenderWindow &screen, Vector2f position, float width, float height, bool enable);

	void SetColorAlpha(sf::Uint8 alpha);

	// Test la collision entre l'image et le point (x, y)
	// Renvoie vrai si la valeur alpha du pixel de l'image est suprieur  100, faux sinon
	bool Collide(float x, float y, float width, float height);
};

#endif
