#include <app/Engine.h>
#include <iostream>

float CEngine::m_lastTime = 0;
float CEngine::m_elapsedTime = 20;

RenderWindow CEngine::m_Screen;

CEngine::CEngine(void):
_FpsLastTime(0.f),
_Fps(0)
{
}

CEngine::~CEngine(void)
{
}

bool CEngine::InitApp( const char *name, unsigned int width, unsigned int height, unsigned int bpp)
{
	m_Screen.Create( VideoMode(width, height, bpp), name );
	//m_Screen.UseVerticalSync(true);
	m_Screen.Clear( Color( 0, 0, 0));

	// Limite max du nombre de FPS
	m_Screen.SetFramerateLimit(60);

	m_Timer.Reset();

    return true;
}

void CEngine::DeInitApp()
{

}

//================
//	Event
bool CEngine::UserEvent()
{
	bool quit = false;
	while( m_Screen.GetEvent(m_Event))		// Traitement de tous les vnements
    {
		switch(m_Event.Type)
        {
			case sf::Event::Closed:          //Si l'utilisateur ferme la fenetre avec le X
                quit = true; break;
			case sf::Event::KeyPressed:
				quit = quit || !KeyPressed(m_Event.Key.Code );
				break;
			case sf::Event::KeyReleased:
				quit = quit || !KeyUnPressed(m_Event.Key.Code);
				break;
			case sf::Event::MouseButtonPressed:
				quit = quit || !MousePressed( m_Event );
				break;
			case sf::Event::MouseButtonReleased:
				quit = quit || !MouseReleased( m_Event );
				break;
			case sf::Event::MouseMoved:
				quit = quit || !MouseOver( m_Event.MouseMove.X, m_Event.MouseMove.Y );
				break;
			case sf::Event::TextEntered:
				quit = quit || !TextEntered( m_Event.Text );
				break;
			case sf::Event::MouseWheelMoved:
				quit = quit || !MouseWheelMoved( m_Event.MouseWheel );
				break;
			//case SDL_JOYBUTTONDOWN:
				//game->KeyPressed((SDLKey) m_Event.ybutton.button ); break;
            default: break;
        }
	}

	return quit;
}

//================
//	Frame Move
bool CEngine::FrameMove()
{
	CalcFps();		// Calcul du FPS afin de contrler la performance du jeu
	float currentTime = m_Timer.GetTicks();
	m_elapsedTime = currentTime - m_lastTime;
	m_lastTime = currentTime;

	return true;
}


void CEngine::CalcFps()
{
    _Fps++;

	if( (m_Timer.GetTicks() - _FpsLastTime) >= 2.0f )
    {
        // nombre de frames par seconde
		std::cout <<  "[FPS: " << _Fps / 2 << "]" << std::endl;
        _Fps = 0;
		_FpsLastTime =  m_Timer.GetTicks();
    }
}
