#include <app/Timer.h>

Timer::Timer(void)
{
   pausedTime = 0.0f;
    pausedTicks = 0.0f;
    paused = false;
    started = false;
}

Timer::~Timer(void)
{
}
void Timer::Reset(void)
{
    started = true;
    paused = false;
   Clock::Reset();
   pausedTime = 0.0f;
}

float Timer::GetTicks()
{
    if( started ) {
        if( paused ) {
            return pausedTicks - pausedTime;
        }
        else {
         return Clock::GetElapsedTime() - pausedTime;
        }
    }
    return 0.0f;
}

void Timer::Pause()
{
    if( ( started  ) && ( !paused  ) )
    {
        paused = true;
      pausedTicks = Clock::GetElapsedTime();
    }
}

void Timer::Unpause()
{
    if( paused )
    {
        paused = false;
      pausedTime += Clock::GetElapsedTime() - pausedTicks;
    }
}

bool Timer::IsStarted()
{
    return started;
}

bool Timer::IsPaused()
{
    return paused;
}
