#include <graphics/Frame.h>

Frame::Frame(void):
CGraphicObject	( 0.f, 0.f, 0, 0),
m_imgFrame		(NULL)
{
}

Frame::Frame( float x, float y, unsigned int width, unsigned int height, FrameImage *Frame):
CGraphicObject	( x, y, width, height),
m_imgFrame		(Frame)
{
}

Frame::~Frame(void)
{
}

void Frame::SetFrameImage( FrameImage *imgFrame)
{
	m_imgFrame = imgFrame;
}

bool Frame::FrameMove( float /*elapsedTime*/ )
{
	return true;
}

void Frame::Render( RenderWindow &screen)
{
	Render( screen, 0.f, 0.f);
}

void Frame::Render( RenderWindow &screen, float dx, float dy)
{
	if( m_imgFrame )
		m_imgFrame->Render( screen, (m_Position.x+dx), (m_Position.y+dy), m_Size.x, m_Size.y);
}

int Frame::GetClientX(void) const
{
	return m_imgFrame->GetLeftSideWidth();
}

int Frame::GetClientY(void) const
{
	return m_imgFrame->GetTopSideWidth();
}

int Frame::GetClientWidth(void) const
{
	return m_Size.x - m_imgFrame->GetLeftSideWidth() - m_imgFrame->GetRightSideWidth();
}

int Frame::GetClientHeight(void) const
{
	return m_Size.y - m_imgFrame->GetTopSideWidth() - m_imgFrame->GetBottomSideWidth();
}
