#include <graphics/FrameImage.h>

FrameImage::FrameImage(void)
{
	for( int i = 0; i < 9; i++)
		m_Bordure[i] = NULL;
}

FrameImage::FrameImage( unsigned int x, unsigned int y, unsigned int width, unsigned int height,
					unsigned int bordHaut, unsigned int bordBas, unsigned int bordGauche, unsigned int bordDroit, const Image& img)
{
	m_BordHorizontal.x = bordHaut;
	m_BordHorizontal.y = bordBas;
	m_BordVertical.x = bordGauche;
	m_BordVertical.y = bordDroit;

	m_Bordure[COIN_HG] =	new CTexture( x, y,						bordGauche,	bordHaut, img);
	m_Bordure[BORD_HAUT] =	new CTexture( x+bordGauche,	y,			width-(bordGauche+bordDroit), bordHaut, img);
	m_Bordure[COIN_HD] =	new CTexture( x+(width-bordDroit), y, bordDroit, bordHaut, img);

	m_Bordure[BORD_GAUCHE] =new CTexture( x,					y+bordHaut,	bordGauche,	height-bordHaut-bordBas, img);
	m_Bordure[FOND] =		new CTexture( x+bordGauche,			y+bordHaut,	width-bordGauche-bordDroit,	height-bordHaut-bordBas, img);
	m_Bordure[BORD_DROITE] =new CTexture( x+(width-bordDroit),y+bordHaut,	bordDroit,	height-bordHaut-bordBas, img);

	m_Bordure[COIN_BG] =	new CTexture( x,					y+(height-bordBas),	bordGauche,	bordBas, img);
	m_Bordure[BORD_BAS] =	new CTexture( x+bordGauche,			y+(height-bordBas),	width-bordGauche-bordDroit,	bordBas, img);
	m_Bordure[COIN_BD] =	new CTexture( x+(width-bordDroit),y+(height-bordBas),	bordDroit,	bordBas, img);
}

FrameImage::~FrameImage()
{
	for( int i = 0; i < 9; i++)
	{
		if( m_Bordure[i] )
			delete m_Bordure[i];
	}
}

bool FrameImage::Render( RenderWindow &screen, float x, float y, unsigned int width, unsigned int height)
{
	if( (int)width <= (m_BordVertical.x + m_BordVertical.y) )
		width = m_BordVertical.x + m_BordVertical.y+1;
	if( (int)height <= (m_BordHorizontal.x + m_BordHorizontal.y) )
		height = m_BordHorizontal.x + m_BordHorizontal.y+1;

	m_Bordure[COIN_HG]->Render( screen, x, y);
	m_Bordure[BORD_HAUT]->Resize( (float)width-m_BordVertical.x-m_BordVertical.y, m_Bordure[BORD_HAUT]->GetSize().y);
	m_Bordure[BORD_HAUT]->Render( screen, x + m_BordVertical.x, y);
	m_Bordure[COIN_HD]->Render( screen, x + width - m_BordVertical.y, y);

	m_Bordure[BORD_GAUCHE]->Resize( m_Bordure[BORD_GAUCHE]->GetSize().x, (float)height-(m_BordHorizontal.x+m_BordHorizontal.y));
	m_Bordure[BORD_GAUCHE]->Render( screen, x, y + m_BordHorizontal.x);
	m_Bordure[FOND]->Resize( (float)width-m_BordVertical.x-m_BordVertical.y, (float)height-(m_BordHorizontal.x+m_BordHorizontal.y));
	m_Bordure[FOND]->Render( screen, x + m_BordVertical.x, y + m_BordHorizontal.x);
	m_Bordure[BORD_DROITE]->Resize( m_Bordure[BORD_DROITE]->GetSize().x, (float)height-(m_BordHorizontal.x+m_BordHorizontal.y));
	m_Bordure[BORD_DROITE]->Render( screen, x + width - m_BordVertical.y, y + m_BordHorizontal.x);

	m_Bordure[COIN_BG]->Render( screen, x, y + height - m_BordHorizontal.y);
	m_Bordure[BORD_BAS]->Resize( (float)width-m_BordVertical.x-m_BordVertical.y, m_Bordure[BORD_BAS]->GetSize().y);
	m_Bordure[BORD_BAS]->Render( screen, x + m_BordVertical.x, y + (float)height - m_BordHorizontal.y);
	m_Bordure[COIN_BD]->Render( screen, x + width - m_BordVertical.y, y + height - m_BordHorizontal.y);

	return true;
}

void FrameImage::Enable(bool enable)
{
	// Dsactiver
	if (m_Enable && !enable)
	{
		for( int i = 0; i < 9; i++)
			m_Bordure[i]->SetColor(Color(100,100,100));
	}
	// Activer
	else if( !m_Enable && enable)
	{
		for( int i = 0; i < 9; i++)
			m_Bordure[i]->SetColor(Color(255,255,255));
	}
	m_Enable = enable;
}
