#include <graphics/GraphicObject.h>

CGraphicObject::CGraphicObject(void):
m_Size		(Vector2i(0,0)),
m_Position	(Vector2f(0,0))
{
}

CGraphicObject::CGraphicObject( float x, float y, unsigned int width, unsigned int height):
m_Size		(Vector2i( width, height)),
m_Position	(Vector2f( x, y))
{
}

CGraphicObject::~CGraphicObject(void)
{
}



//=================================
//
//=================================
CGraphicObjectVector::~CGraphicObjectVector()
{
	DeleteAll();
}


void CGraphicObjectVector::DeleteAll()
{
	for( unsigned int i = 0; i < size(); i++)
		delete at(i);
	clear();
}

bool CGraphicObjectVector::FrameMove( float elapsedTime)
{
	bool b = false;
	for( unsigned int i = 0; i < size(); i++)
		b = !at(i)->FrameMove(elapsedTime);
	return !b;
}

void CGraphicObjectVector::Render( RenderWindow &screen)
{
	Render(screen, 0, 0);
}

void CGraphicObjectVector::Render( RenderWindow &screen, float dx, float dy)
{
	for( unsigned int i = 0; i < size(); i++)
		at(i)->Render(screen, dx, dy);
}
