#include <gui/Button.h>

Button::Button(int x, int y, int width, int height, int id, WidgetImage *widgetImg) :
StaticLabel(x, y, width, height, widgetImg)
{
	m_imgNormal = widgetImg;
	m_Id = id;
	m_imgHover = NULL;
	m_Hover = false;
	m_pFontNormal = m_pFont;
	m_pFontHover = NULL;
}

Button::Button(int x, int y, int width, int height, int id, WidgetImage *widgetImg,
	CFont *font, int tx, int ty, string texte) :
StaticLabel(x, y, width, height, widgetImg, font, tx, ty, texte)
{
	m_imgNormal = widgetImg;
	m_Id = id;
	m_imgHover = NULL;
	m_Hover = false;
	m_pFontNormal = m_pFont;
	m_pFontHover = NULL;
}

Button::~Button()
{

}

void Button::Render(RenderWindow &screen, Vector2i offset)
{
	m_Background = m_imgNormal;
	m_pFont = m_pFontNormal;
	if (m_Hover)
	{
		if (m_imgHover != NULL)
			m_Background = m_imgHover;
		if( m_pFontHover != NULL)
			m_pFont = m_pFontHover;
	}

	StaticLabel::Render(screen, offset);
}

bool Button::Collide(int x, int y)
{
	return m_imgNormal->Collide((float)(x - m_Position.x),
		(float)(y - m_Position.y),
		(float)m_Size.x,
		(float)m_Size.y);
}

void Button::SetWidgetImage(WidgetImage *img)
{
	m_imgNormal = img;
}
